package com.ruoyi.framework.web.service;

import javax.annotation.Resource;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson2.JSON;
import com.ruoyi.cms.service.IAppUserService;
import com.ruoyi.cms.util.WechatUtil;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.entity.AppUser;
import com.ruoyi.common.core.domain.model.LoginBody;
import com.ruoyi.common.core.domain.model.LoginSiteUser;
import com.ruoyi.common.core.domain.model.RegisterBody;
import com.ruoyi.common.utils.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.authentication.BadCredentialsException;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.stereotype.Component;
import com.ruoyi.common.constant.CacheConstants;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.constant.UserConstants;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.core.redis.RedisCache;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.exception.user.BlackListException;
import com.ruoyi.common.exception.user.CaptchaException;
import com.ruoyi.common.exception.user.CaptchaExpireException;
import com.ruoyi.common.exception.user.UserNotExistsException;
import com.ruoyi.common.exception.user.UserPasswordNotMatchException;
import com.ruoyi.common.utils.ip.IpUtils;
import com.ruoyi.framework.manager.AsyncManager;
import com.ruoyi.framework.manager.factory.AsyncFactory;
import com.ruoyi.framework.security.context.AuthenticationContextHolder;
import com.ruoyi.system.service.ISysConfigService;
import com.ruoyi.system.service.ISysUserService;

/**
 * 登录校验方法
 * 
 * @author ruoyi
 */
@Component
public class SysLoginService
{
    @Autowired
    private TokenService tokenService;

    @Resource
    private AuthenticationManager authenticationManager;

    @Autowired
    private RedisCache redisCache;
    
    @Autowired
    private ISysUserService userService;

    @Autowired
    private ISysConfigService configService;

    @Autowired
    private TokenSiteService tokenSiteService;
    @Autowired
    WechatUtil wechatUtil;
    @Autowired
    private IAppUserService appUserService;
    /**
     * 登录验证
     * 
     * @param username 用户名
     * @param password 密码
     * @param code 验证码
     * @param uuid 唯一标识
     * @return 结果
     */
    public String login(String username, String password, String code, String uuid)
    {
        // 验证码校验
        validateCaptcha(username, code, uuid);
        // 登录前置校验
        loginPreCheck(username, password);
        // 用户验证
        Authentication authentication = null;
        try
        {
            UsernamePasswordAuthenticationToken authenticationToken = new UsernamePasswordAuthenticationToken(username, password);
            AuthenticationContextHolder.setContext(authenticationToken);
            // 该方法会去调用UserDetailsServiceImpl.loadUserByUsername
            authentication = authenticationManager.authenticate(authenticationToken);
        }
        catch (Exception e)
        {
            if (e instanceof BadCredentialsException)
            {
                AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.LOGIN_FAIL, MessageUtils.message("user.password.not.match")));
                throw new UserPasswordNotMatchException();
            }
            else
            {
                AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.LOGIN_FAIL, e.getMessage()));
                throw new ServiceException(e.getMessage());
            }
        }
        finally
        {
            AuthenticationContextHolder.clearContext();
        }
        AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.LOGIN_SUCCESS, MessageUtils.message("user.login.success")));
        LoginUser loginUser = (LoginUser) authentication.getPrincipal();
        recordLoginInfo(loginUser.getUserId());
        // 生成token
        return tokenService.createToken(loginUser);
    }
    //模拟登录
    public String loginApp(String username, String password)
    {

        AppUser appUser = userService.selectAppUserById(1L);
        LoginSiteUser loginSiteUser = new LoginSiteUser();
        loginSiteUser.setUserId(appUser.getUserId());
        loginSiteUser.setUser(appUser);
        recordLoginInfo(appUser);
        AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.LOGIN_SUCCESS, MessageUtils.message("user.login.success")));
        recordLoginInfo(appUser);
        // 生成token
        return tokenSiteService.createToken(loginSiteUser);
    }

    /**
     * 根据微信生成的
     * @param appUser
     * @return
     */
    public String loginUserIdApp(AppUser appUser)
    {
        LoginSiteUser loginSiteUser = new LoginSiteUser();
        loginSiteUser.setUserId(appUser.getUserId());
        loginSiteUser.setUser(appUser);
        recordLoginInfo(appUser);
        AsyncManager.me().execute(AsyncFactory.recordLogininfor(appUser.getName(), Constants.LOGIN_SUCCESS, MessageUtils.message("user.login.success")));
        recordLoginInfo(appUser);
        // 生成token //tokenSiteService.createToken(loginSiteUser) 有时间
        return tokenSiteService.noExpireCreateToken(loginSiteUser);
    }

    //单点登录
    public String loginOss(String ticket)
    {
        return "tokenService.createToken(loginUser)";
    }
    /**
     * 校验验证码
     * 
     * @param username 用户名
     * @param code 验证码
     * @param uuid 唯一标识
     * @return 结果
     */
    public void validateCaptcha(String username, String code, String uuid)
    {
        boolean captchaEnabled = configService.selectCaptchaEnabled();
        if (captchaEnabled)
        {
            String verifyKey = CacheConstants.CAPTCHA_CODE_KEY + StringUtils.nvl(uuid, "");
            String captcha = redisCache.getCacheObject(verifyKey);
            if (captcha == null)
            {
                AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.LOGIN_FAIL, MessageUtils.message("user.jcaptcha.expire")));
                throw new CaptchaExpireException();
            }
            redisCache.deleteObject(verifyKey);
            if (!code.equalsIgnoreCase(captcha))
            {
                AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.LOGIN_FAIL, MessageUtils.message("user.jcaptcha.error")));
                throw new CaptchaException();
            }
        }
    }
    public void recordLoginInfo(AppUser user)
    {
        AppUser sysUser = new AppUser();
        sysUser.setUserId(user.getUserId());
        sysUser.setLoginIp(IpUtils.getIpAddr());
        sysUser.setLoginDate(DateUtils.getNowDate());
        sysUser.setUpdateBy(user.getName());
//        userService.updateSiteUser(sysUser);
    }
    /**
     * 登录前置校验
     * @param username 用户名
     * @param password 用户密码
     */
    public void loginPreCheck(String username, String password)
    {
        // 用户名或密码为空 错误
        if (StringUtils.isEmpty(username) || StringUtils.isEmpty(password))
        {
            AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.LOGIN_FAIL, MessageUtils.message("not.null")));
            throw new UserNotExistsException();
        }
        // 密码如果不在指定范围内 错误
        if (password.length() < UserConstants.PASSWORD_MIN_LENGTH
                || password.length() > UserConstants.PASSWORD_MAX_LENGTH)
        {
            AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.LOGIN_FAIL, MessageUtils.message("user.password.not.match")));
            throw new UserPasswordNotMatchException();
        }
        // 用户名不在指定范围内 错误
        if (username.length() < UserConstants.USERNAME_MIN_LENGTH
                || username.length() > UserConstants.USERNAME_MAX_LENGTH)
        {
            AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.LOGIN_FAIL, MessageUtils.message("user.password.not.match")));
            throw new UserPasswordNotMatchException();
        }
        // IP黑名单校验
        String blackStr = configService.selectConfigByKey("sys.login.blackIPList");
        if (IpUtils.isMatchedIp(blackStr, IpUtils.getIpAddr()))
        {
            AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.LOGIN_FAIL, MessageUtils.message("login.blocked")));
            throw new BlackListException();
        }
    }

    /**
     * 记录登录信息
     *
     * @param userId 用户ID
     */
    public void recordLoginInfo(Long userId)
    {
        SysUser sysUser = new SysUser();
        sysUser.setUserId(userId);
        sysUser.setLoginIp(IpUtils.getIpAddr());
        sysUser.setLoginDate(DateUtils.getNowDate());
        userService.updateUserProfile(sysUser);
    }

    /**
     * 小程序微信授权登录
     * @param dto
     * @return
     */
    public AjaxResult appLogin(LoginBody dto){
        AjaxResult ajax = AjaxResult.success();
        System.out.println("小程序微信授权登录---------参数列表========dto========"+ JSON.toJSONString(dto));
        JSONObject sessionInfo = wechatUtil.code2Session(dto.getCode());
        String openid = sessionInfo.getString("openid");
        String unionid = sessionInfo.getString("unionid");
        String sessionKey = sessionInfo.getString("session_key");
        if (openid == null) {
            return AjaxResult.error("微信授权失败");
        }
        //验证是否登录过
        AppUser existingUser=appUserService.selectByOpenid(openid);
        if(existingUser!=null){
            if(StringUtils.isEmpty(existingUser.getIsCompanyUser())){
                existingUser.setIsCompanyUser(dto.getUserType());
                appUserService.updateAppUser(existingUser);
            }
            String token = loginUserIdApp(existingUser);
            ajax.put(Constants.TOKEN, token);
            ajax.put("isNewUser", false);
            ajax.put("idCard",existingUser.getIdCard());
            ajax.put("isCompanyUser",existingUser.getIsCompanyUser());
            return ajax;
        }else {
            JSONObject phoneInfo = wechatUtil.decryptPhoneNumber(dto.getEncryptedData(), sessionKey, dto.getIv());
            String phone = phoneInfo.getString("phoneNumber");
            if (phone == null) {
                return AjaxResult.error("获取手机号失败");
            }

            // 3. 检查手机号是否已被绑定
            AppUser existUser = appUserService.getPhone(phone);
            String token="";
            boolean isNewUser=false;
            if (existUser != null) {
                existUser.setOpenid(openid);
                appUserService.updateAppUser(existUser);
                // 5. 生成系统令牌
                token = loginUserIdApp(existUser);
                ajax.put("idCard",existUser.getIdCard());
                ajax.put("isCompanyUser",existUser.getIsCompanyUser());
            }else{
                // 4. 创建用户并存储所有信息
                AppUser appUser = new AppUser();
                appUser.setOpenid(openid);
                appUser.setUnionid(unionid);
                appUser.setPhone(phone);
                appUser.setIsCompanyUser(dto.getUserType());//保存角色
                appUserService.insertAppUser(appUser);
                // 5. 生成系统令牌
                token = loginUserIdApp(appUser);
                isNewUser=true;
                ajax.put("idCard",null);
                ajax.put("isCompanyUser",dto.getUserType());
            }
            ajax.put("isNewUser", isNewUser);
            ajax.put(Constants.TOKEN, token);
            return ajax;
        }
    }

    /**
     * 注册
     * @param registerBody
     * @return
     */
    public String registerAppUser(RegisterBody registerBody) {
        AppUser appUser=appUserService.registerAppUser(registerBody);
        return loginUserIdApp(appUser);
    }
}
